Index: lib/application.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/application.cc,v
retrieving revision 1.73.2.10
diff -p -u -5 -r1.73.2.10 application.cc
--- lib/application.cc	29 Oct 2007 13:56:07 -0000	1.73.2.10
+++ lib/application.cc	10 Dec 2007 20:56:20 -0000
@@ -56,10 +56,11 @@
 #	include <fstream>
 #else
 #	include <fstream.h>
 #endif
 #include <clocale>
+#include <cstring>
 
 // following code is needed to get file extensions, it as been essentially copied from gnome-vfs
 static map<string, list<string> > globs;
 
 static void load_globs_from_dir (char const *directory)
Index: lib/arrow.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/arrow.cc,v
retrieving revision 1.12.2.1
diff -p -u -5 -r1.12.2.1 arrow.cc
--- lib/arrow.cc	6 Apr 2007 16:36:00 -0000	1.12.2.1
+++ lib/arrow.cc	10 Dec 2007 20:56:20 -0000
@@ -28,10 +28,11 @@
 #include "settings.h"
 #include "libgcpcanvas/gcp-canvas-line.h"
 #include "libgcpcanvas/gprintable.h"
 #include "arrow.h"
 #include "document.h"
+#include <cstring>
 
 gcpArrow::gcpArrow(TypeId Type): Object(Type)
 {
 }
 
Index: lib/atom.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/atom.cc,v
retrieving revision 1.37.2.6
diff -p -u -5 -r1.37.2.6 atom.cc
--- lib/atom.cc	10 May 2007 14:04:24 -0000	1.37.2.6
+++ lib/atom.cc	10 Dec 2007 20:56:20 -0000
@@ -38,10 +38,11 @@
 #include "libgcpcanvas/gcp-canvas-pango.h"
 #include <gcu/element.h>
 #include <openbabel/mol.h>
 #include <glib/gi18n-lib.h>
 #include <cmath>
+#include <cstring>
 
 using namespace gcu;
 
 #define ATOM_EPSILON 0.1
 
Index: lib/bond.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/bond.cc,v
retrieving revision 1.23.2.3
diff -p -u -5 -r1.23.2.3 bond.cc
--- lib/bond.cc	9 May 2007 16:40:37 -0000	1.23.2.3
+++ lib/bond.cc	10 Dec 2007 20:56:20 -0000
@@ -36,10 +36,11 @@
 #include "libgcpcanvas/gcp-canvas-line.h"
 #include "libgcpcanvas/gcp-canvas-bpath.h"
 #include "libgcpcanvas/gcp-canvas-polygon.h"
 #include <glib/gi18n-lib.h>
 #include <cmath>
+#include <cstring>
 
 gcpBond::gcpBond(): Bond()
 {
 	m_CoordsCalc = false;
 	m_type = NormalBondType;
Index: lib/document.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/document.cc,v
retrieving revision 1.69.2.7
diff -p -u -5 -r1.69.2.7 document.cc
--- lib/document.cc	29 Oct 2007 13:56:08 -0000	1.69.2.7
+++ lib/document.cc	10 Dec 2007 20:56:21 -0000
@@ -44,10 +44,11 @@
 #include <glib/gi18n-lib.h>
 #include <openbabel/mol.h>
 #include <openbabel/obconversion.h>
 #include <clocale>
 #include <stack>
+#include <cstring>
 
 using namespace OpenBabel;
 using namespace std;
 
 SignalId OnChangedSignal;
Index: lib/electron.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/electron.cc,v
retrieving revision 1.8.2.3
diff -p -u -5 -r1.8.2.3 electron.cc
--- lib/electron.cc	22 Apr 2007 15:06:33 -0000	1.8.2.3
+++ lib/electron.cc	10 Dec 2007 20:56:21 -0000
@@ -31,10 +31,11 @@
 #include "view.h"
 #include "widgetdata.h"
 #include "libgcpcanvas/gcp-canvas-rect-ellipse.h"
 #include "libgcpcanvas/gcp-canvas-group.h"
 #include <cmath>
+#include <cstring>
 
 #define POSITION_NE 1
 #define POSITION_NW 2
 #define POSITION_N 4
 #define POSITION_SE 8
Index: lib/fontsel.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/fontsel.cc,v
retrieving revision 1.4.2.3
diff -p -u -5 -r1.4.2.3 fontsel.cc
--- lib/fontsel.cc	9 Sep 2007 07:33:25 -0000	1.4.2.3
+++ lib/fontsel.cc	10 Dec 2007 20:56:21 -0000
@@ -33,10 +33,11 @@
 #include <gsf/gsf-impl-utils.h>
 #include <glib/gi18n-lib.h>
 #include <cstdlib>
 #include <map>
 #include <string>
+#include <cstring>
 
 using namespace std;
 
 struct _GcpFontSel {
 	GtkBin base;
Index: lib/fragment-atom.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/fragment-atom.cc,v
retrieving revision 1.11.2.1
diff -p -u -5 -r1.11.2.1 fragment-atom.cc
--- lib/fragment-atom.cc	6 Apr 2007 16:36:00 -0000	1.11.2.1
+++ lib/fragment-atom.cc	10 Dec 2007 20:56:21 -0000
@@ -25,10 +25,11 @@
 #include "gchempaint-config.h"
 #include "fragment-atom.h"
 #include "fragment.h"
 #include "molecule.h"
 #include <gcu/element.h>
+#include <cstring>
 
 gcpFragmentAtom::gcpFragmentAtom(): gcpAtom()
 {
 	SetId ((char*) "a1");
 }
Index: lib/fragment.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/fragment.cc,v
retrieving revision 1.41.2.2
diff -p -u -5 -r1.41.2.2 fragment.cc
--- lib/fragment.cc	9 Apr 2007 11:50:25 -0000	1.41.2.2
+++ lib/fragment.cc	10 Dec 2007 20:56:22 -0000
@@ -37,12 +37,13 @@
 #include "libgcpcanvas/gcp-canvas-rect-ellipse.h"
 #include "libgcpcanvas/gcp-canvas-bpath.h"
 #include <gcu/element.h>
 #include <pango/pango-attributes.h>
 #include <glib/gi18n-lib.h>
-#include <cmath>
 #include <list>
+#include <cmath>
+#include <cstring>
 
 static void on_fragment_changed (gcpFragment *fragment)
 {
 	fragment->OnChanged (true);
 }
Index: lib/mesomery.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/mesomery.cc,v
retrieving revision 1.31.2.4
diff -p -u -5 -r1.31.2.4 mesomery.cc
--- lib/mesomery.cc	14 Oct 2007 14:44:22 -0000	1.31.2.4
+++ lib/mesomery.cc	10 Dec 2007 20:56:22 -0000
@@ -31,10 +31,11 @@
 #include "mesomery-arrow.h"
 #include "mesomer.h"
 #include <glib/gi18n-lib.h>
 #include <cmath>
 #include <set>
+#include <cstring>
 
 gcpMesomery::gcpMesomery (): Object (MesomeryType)
 {
 	SetId ((char*) "msy1");
 }
Index: lib/molecule.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/molecule.cc,v
retrieving revision 1.34.2.4
diff -p -u -5 -r1.34.2.4 molecule.cc
--- lib/molecule.cc	9 May 2007 16:40:37 -0000	1.34.2.4
+++ lib/molecule.cc	10 Dec 2007 20:56:22 -0000
@@ -32,10 +32,11 @@
 #include <glib/gi18n-lib.h>
 #include <unistd.h>
 #include <openbabel/obconversion.h>
 #include <cmath>
 #include <clocale>
+#include <cstring>
 
 static void do_export_to_ghemical (gcpMolecule* pMol)
 {
 	pMol->ExportToGhemical ();
 }
Index: lib/operation.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/operation.cc,v
retrieving revision 1.8
diff -p -u -5 -r1.8 operation.cc
--- lib/operation.cc	29 Oct 2006 16:17:29 -0000	1.8
+++ lib/operation.cc	10 Dec 2007 20:56:22 -0000
@@ -23,10 +23,11 @@
  */
 
 #include "gchempaint-config.h"
 #include "operation.h"
 #include "document.h"
+#include <cstring>
 
 xmlDocPtr pXmlDoc = xmlNewDoc((const xmlChar*)"1.0");//Needed to create xmlNodes
 
 gcpOperation::gcpOperation(gcpDocument* pDoc, unsigned long ID):
 	m_pDoc (pDoc),
Index: lib/plugin.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/plugin.cc,v
retrieving revision 1.14.2.2
diff -p -u -5 -r1.14.2.2 plugin.cc
--- lib/plugin.cc	7 May 2007 16:27:11 -0000	1.14.2.2
+++ lib/plugin.cc	10 Dec 2007 20:56:22 -0000
@@ -25,10 +25,11 @@
 #include "gchempaint-config.h"
 #include "plugin.h"
 #include "application.h"
 #include <dlfcn.h>
 #include <glib.h>
+#include <cstring>
 
 set<gcpPlugin*> Plugins;
 
 gcpPlugin::gcpPlugin ()
 {
Index: lib/preferences.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/preferences.cc,v
retrieving revision 1.12.2.7
diff -p -u -5 -r1.12.2.7 preferences.cc
--- lib/preferences.cc	21 Oct 2007 11:54:45 -0000	1.12.2.7
+++ lib/preferences.cc	10 Dec 2007 20:56:23 -0000
@@ -29,10 +29,11 @@
 #include "fontsel.h"
 #include "settings.h"
 #include "theme.h"
 #include <glib/gi18n-lib.h>
 #include <sys/stat.h>
+#include <cstring>
 
 static int get_fontstyle (PangoStyle val)
 {
 	switch (val) {
 		case PANGO_STYLE_NORMAL: return 0;
Index: lib/reactant.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/reactant.cc,v
retrieving revision 1.16.2.3
diff -p -u -5 -r1.16.2.3 reactant.cc
--- lib/reactant.cc	9 May 2007 16:40:37 -0000	1.16.2.3
+++ lib/reactant.cc	10 Dec 2007 20:56:23 -0000
@@ -28,10 +28,11 @@
 #include "application.h"
 #include "document.h"
 #include "text.h"
 #include "theme.h"
 #include <glib/gi18n-lib.h>
+#include <cstring>
 
 extern xmlDocPtr pXmlDoc;
 
 gcpReactant::gcpReactant (): Object (ReactantType)
 {
Index: lib/reaction-arrow.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/reaction-arrow.cc,v
retrieving revision 1.14.2.1
diff -p -u -5 -r1.14.2.1 reaction-arrow.cc
--- lib/reaction-arrow.cc	6 Apr 2007 16:36:00 -0000	1.14.2.1
+++ lib/reaction-arrow.cc	10 Dec 2007 20:56:23 -0000
@@ -32,10 +32,11 @@
 #include "view.h"
 #include "widgetdata.h"
 #include "libgcpcanvas/gcp-canvas-group.h"
 #include "libgcpcanvas/gcp-canvas-line.h"
 #include <cmath>
+#include <cstring>
 
 gcpReactionArrow::gcpReactionArrow (gcpReaction* react, unsigned Type): gcpArrow (ReactionArrowType)
 {
 	SetId ((char*) "ra1");
 	m_Type = Type;
Index: lib/reaction-operator.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/reaction-operator.cc,v
retrieving revision 1.7.2.1
diff -p -u -5 -r1.7.2.1 reaction-operator.cc
--- lib/reaction-operator.cc	6 Apr 2007 16:36:00 -0000	1.7.2.1
+++ lib/reaction-operator.cc	10 Dec 2007 20:56:23 -0000
@@ -31,10 +31,11 @@
 #include "widgetdata.h"
 #include "libgcpcanvas/gcp-canvas-group.h"
 #include "libgcpcanvas/gcp-canvas-rect-ellipse.h"
 #include "libgcpcanvas/gcp-canvas-pango.h"
 #include <cmath>
+#include <cstring>
 
 gcpReactionOperator::gcpReactionOperator (): Object (ReactionOperatorType)
 {
 }
 
Index: lib/reaction.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/reaction.cc,v
retrieving revision 1.30.2.3
diff -p -u -5 -r1.30.2.3 reaction.cc
--- lib/reaction.cc	9 May 2007 16:40:37 -0000	1.30.2.3
+++ lib/reaction.cc	10 Dec 2007 20:56:23 -0000
@@ -29,10 +29,11 @@
 #include "document.h"
 #include "theme.h"
 #include "view.h"
 #include <glib/gi18n-lib.h>
 #include <cmath>
+#include <cstring>
 
 gcpReaction::gcpReaction (): Object (ReactionType)
 {
 	SetId ((char*) "rxn1");
 }
Index: lib/stringdlg.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/stringdlg.cc,v
retrieving revision 1.7.2.2
diff -p -u -5 -r1.7.2.2 stringdlg.cc
--- lib/stringdlg.cc	7 May 2007 16:27:11 -0000	1.7.2.2
+++ lib/stringdlg.cc	10 Dec 2007 20:56:23 -0000
@@ -28,10 +28,11 @@
 #include "application.h"
 #include "window.h"
 #include <libgnomevfs/gnome-vfs-ops.h>
 #include <libgnomevfs/gnome-vfs-utils.h>
 #include <glib/gi18n-lib.h>
+#include <cstring>
 
 static GtkTargetEntry const stargets[] = {
 	{(char *)"STRING", 0, 0}
 };
 
Index: lib/text-object.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/text-object.cc,v
retrieving revision 1.14
diff -p -u -5 -r1.14 text-object.cc
--- lib/text-object.cc	31 Oct 2006 11:12:26 -0000	1.14
+++ lib/text-object.cc	10 Dec 2007 20:56:23 -0000
@@ -26,10 +26,11 @@
 #include "text-object.h"
 #include "document.h"
 #include "window.h"
 #include <libgcpcanvas/gcp-canvas-pango.h>
 #include <gcu/xml-utils.h>
+#include <cstring>
 
 extern xmlDocPtr pXmlDoc;
 
 gcpTextObject::gcpTextObject (TypeId Type): Object (Type)
 {
Index: lib/text.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/text.cc,v
retrieving revision 1.29.2.1
diff -p -u -5 -r1.29.2.1 text.cc
--- lib/text.cc	6 Apr 2007 16:36:00 -0000	1.29.2.1
+++ lib/text.cc	10 Dec 2007 20:56:23 -0000
@@ -34,10 +34,11 @@
 #include "libgcpcanvas/gcp-canvas-group.h"
 #include "libgcpcanvas/gcp-canvas-rect-ellipse.h"
 #include "libgcpcanvas/gprintable.h"
 #include <glib/gi18n-lib.h>
 #include <stdexcept>
+#include <cstring>
 
 static void on_text_changed (gcpText *text)
 {
 	text->OnChanged (true);
 }
Index: lib/theme.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/theme.cc,v
retrieving revision 1.18.2.10
diff -p -u -5 -r1.18.2.10 theme.cc
--- lib/theme.cc	21 Oct 2007 11:54:45 -0000	1.18.2.10
+++ lib/theme.cc	10 Dec 2007 20:56:24 -0000
@@ -27,10 +27,11 @@
 #include "theme.h"
 #include "settings.h"
 #include <glib/gi18n-lib.h>
 #include <sys/stat.h>
 #include <cmath>
+#include <cstring>
 
 double DefaultBondLength = 140.;
 double DefaultBondAngle = 120.;
 double DefaultBondDist = 5.;
 double DefaultBondWidth = 1.0;
Index: lib/tools.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/tools.cc,v
retrieving revision 1.11.2.3
diff -p -u -5 -r1.11.2.3 tools.cc
--- lib/tools.cc	12 Jul 2007 10:32:42 -0000	1.11.2.3
+++ lib/tools.cc	10 Dec 2007 20:56:24 -0000
@@ -26,10 +26,11 @@
 #include "application.h"
 #include "settings.h"
 #include "tools.h"
 #include <gcu/gtkcomboperiodic.h>
 #include <goffice/gtk/go-combo-box.h>
+#include <cstring>
 
 static void element_changed_cb (gcpTools *box, unsigned newZ)
 {
 	box->OnElementChanged (newZ);
 }
Index: lib/view.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/view.cc,v
retrieving revision 1.60.2.9
diff -p -u -5 -r1.60.2.9 view.cc
--- lib/view.cc	14 Oct 2007 14:44:23 -0000	1.60.2.9
+++ lib/view.cc	10 Dec 2007 20:56:24 -0000
@@ -49,10 +49,11 @@
 #else
 #	include <fstream.h>
 #endif
 #include <map>
 #include <string>
+#include <cstring>
 
 /*
 Derivation of a new widget from gnome_canvas with an event for updating canvas size
 */
 
Index: lib/widgetdata.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/lib/widgetdata.cc,v
retrieving revision 1.18.2.2
diff -p -u -5 -r1.18.2.2 widgetdata.cc
--- lib/widgetdata.cc	9 Jun 2007 09:13:51 -0000	1.18.2.2
+++ lib/widgetdata.cc	10 Dec 2007 20:56:24 -0000
@@ -28,10 +28,11 @@
 #include "settings.h"
 #include "document.h"
 #include "application.h"
 #include "operation.h"
 #include "theme.h"
+#include <cstring>
 
 static xmlDocPtr pXmlDoc = NULL, pXmlDoc1 = NULL;
 xmlChar* ClipboardData = NULL;
 guint ClipboardDataType, ClipboardDataType1;
 bool cleared = true;
Index: plugins/templates/plugin.cc
===================================================================
RCS file: /sources/gchempaint/gchempaint/plugins/templates/plugin.cc,v
retrieving revision 1.15.2.1
diff -p -u -5 -r1.15.2.1 plugin.cc
--- plugins/templates/plugin.cc	7 May 2007 16:27:11 -0000	1.15.2.1
+++ plugins/templates/plugin.cc	10 Dec 2007 20:56:25 -0000
@@ -28,10 +28,11 @@
 #include "templatetool.h"
 #include "templatetree.h"
 #include "category.h"
 #include <glib/gi18n-lib.h>
 #include <sys/stat.h>
+#include <cstring>
 
 gcpTemplatesPlugin plugin;
 extern set<xmlDocPtr> docs;
 
 gcpTemplatesPlugin::gcpTemplatesPlugin(): gcpPlugin()