diff --git a/bash_completion b/bash_completion
index 9fd0ebf..a006c1c 100644
--- a/bash_completion
+++ b/bash_completion
@@ -123,7 +123,7 @@ _quilt_completion()
 	add)
 	   case $prev in
 	     -P)
- 	        COMPREPLY=( $( compgen -W "$(quilt applied)" -- $cur ) )
+ 	        COMPREPLY=( $( compgen -W "$(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     *)
 	        _quilt_comfile
@@ -134,7 +134,7 @@ _quilt_completion()
 	annotate)
 	   case $prev in
 	     -P)
- 	        COMPREPLY=( $( compgen -W "$(quilt applied)" -- $cur ) )
+ 	        COMPREPLY=( $( compgen -W "$(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     *)
 	        _quilt_comfile
@@ -143,10 +143,10 @@ _quilt_completion()
 	   esac
 	   ;;
 	applied) 
-	   COMPREPLY=( $( compgen -W "-h $(quilt applied)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-h $(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	delete) 
-	   COMPREPLY=( $( compgen -W "-n -r -h --backup $(quilt series)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-n -r -h --backup $(quilt series | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	diff) 
 	   case $prev in
@@ -154,7 +154,7 @@ _quilt_completion()
  	        COMPREPLY=( $( compgen -W "0 1" -- $cur ) )
 		;;
 	     -P|--combine)
-	     	COMPREPLY=( $( compgen -W "$(quilt applied)" -- $cur ) )
+	     	COMPREPLY=( $( compgen -W "$(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     --diff|-U|-C)
 		;;
@@ -171,10 +171,10 @@ _quilt_completion()
 	files)
 	   case $prev in
 	     --combine)
-		COMPREPLY=( $( compgen -W "$(quilt applied)" -- $cur ) )
+		COMPREPLY=( $( compgen -W "$(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     *)
-		COMPREPLY=( $( compgen -W "-a -l -v -h --combine $(quilt applied)" -- $cur ) )
+		COMPREPLY=( $( compgen -W "-a -l -v -h --combine $(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	   esac
 	   ;;
@@ -198,7 +198,7 @@ _quilt_completion()
 	        COMPREPLY=( $( compgen -W "files" -- $cur ) )
 		;;
 	     *)
-		COMPREPLY=( $( compgen -W "-T -h --all --reduce --lines --edge-labels $(quilt applied)" -- $cur ) )
+		COMPREPLY=( $( compgen -W "-T -h --all --reduce --lines --edge-labels $(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	   esac
 	   ;;
@@ -207,7 +207,7 @@ _quilt_completion()
 	   COMPREPLY=( ${COMPREPLY[@]:-} $( compgen -W "-h" -- $cur ) )
 	   ;;
 	header)
-	   COMPREPLY=( $( compgen -W "-a -e -h -r --backup --strip-diffstat --strip-trailing-whitespace $(quilt series)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-a -e -h -r --backup --strip-diffstat --strip-trailing-whitespace $(quilt series | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	import)
 	   case $prev in
@@ -229,17 +229,17 @@ _quilt_completion()
 	   COMPREPLY=( $( compgen -W "-m --prefix --mbox --send --sender --from --subject --to --cc --bcc" -- $cur ) )
 	   ;;
 	next|previous)
-	   COMPREPLY=( $( compgen -W "$(quilt series)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "$(quilt series | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	patches)
 	   _quilt_comfile 
 	   COMPREPLY=( ${COMPREPLY[@]:-} $( compgen -W "-v -h" -- $cur ) )
 	   ;;
 	pop)
-	   COMPREPLY=( $( compgen -W "-a -f -R -q -v -h $(quilt applied)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-a -f -R -q -v -h $(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	push)
-	   COMPREPLY=( $( compgen -W "-a -f -q -v -h --leave-rejects --interactive --color $(quilt unapplied)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-a -f -q -v -h --leave-rejects --interactive --color $(quilt unapplied | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	refresh)
 	   case $prev in
@@ -249,14 +249,14 @@ _quilt_completion()
 	     -U|-C)
 		;;
 	     *)
-	     	COMPREPLY=( $( compgen -W "-p -u -U -c -C -f -h $(quilt applied) --no-timestamps --no-index --diffstat --sort --backup --strip-trailing-whitespace" -- $cur ) )
+	     	COMPREPLY=( $( compgen -W "-p -u -U -c -C -f -h $(quilt applied | sed -e 's:.*/::') --no-timestamps --no-index --diffstat --sort --backup --strip-trailing-whitespace" -- $cur ) )
 		;;
 	   esac
 	   ;;
 	remove)
 	   case $prev in
 	     -P)
- 	        COMPREPLY=( $( compgen -W "$(quilt applied)" -- $cur ) )
+ 	        COMPREPLY=( $( compgen -W "$(quilt applied | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     *)
 	        _quilt_comfile 
@@ -267,7 +267,7 @@ _quilt_completion()
 	rename)
 	   case $prev in
 	     -P)
-		COMPREPLY=( $( compgen -W "$(quilt series)" -- $cur ) )
+		COMPREPLY=( $( compgen -W "$(quilt series | sed -e 's:.*/::')" -- $cur ) )
 		;;
 	     *)
 		COMPREPLY=( $( compgen -W "-P -h" -- $cur ) )
@@ -292,7 +292,7 @@ _quilt_completion()
 	   COMPREPLY=( $( compgen -W "-d -h" -- $cur ) )
 	   ;;
 	unapplied)
-	   COMPREPLY=( $( compgen -W "-h $(quilt series)" -- $cur ) )
+	   COMPREPLY=( $( compgen -W "-h $(quilt series | sed -e 's:.*/::')" -- $cur ) )
 	   ;;
 	fork|new|top|upgrade)
 	   ;;